"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDriverFactory = void 0;
var React = require("react");
var react_dom_1 = require("react-dom");
var react_helpers_1 = require("../react-helpers");
function componentFactory(Component) {
    var element;
    var eventTrigger = react_helpers_1.reactEventTrigger();
    var wrapperDiv = document.createElement('div');
    react_dom_1.render(React.createElement("div", { ref: function (r) { return element = r; } }, Component), wrapperDiv);
    return { element: element && element.childNodes[0], wrapper: wrapperDiv, component: Component, eventTrigger: eventTrigger };
}
function createDriverFactory(driverFactory) {
    return function (Component) { return driverFactory(componentFactory(Component)); };
}
exports.createDriverFactory = createDriverFactory;
//# sourceMappingURL=createDriverFactory.js.map