"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUniEnzymeTestkitExists = exports.isEnzymeTestkitExists = exports.enzymeUniTestkitFactoryCreator = exports.enzymeTestkitFactoryCreator = void 0;
var React = require("react");
var react_helpers_1 = require("../react-helpers");
var jsdom_react_1 = require("@unidriver/jsdom-react");
function enzymeTestkitFactoryCreator(driverFactory) {
    return function (obj) {
        var eventTrigger = react_helpers_1.reactEventTrigger();
        var regexp = new RegExp("^<[^>]+data-hook=\"" + obj.dataHook + "\"");
        var component = obj.wrapper.findWhere(function (n) { return n.length > 0 && typeof n.type() === 'string' && regexp.test(n.html()); });
        var element = component.length > 0 ? component.first().getDOMNode() : undefined;
        return driverFactory({
            element: element,
            wrapper: obj.wrapper,
            eventTrigger: eventTrigger,
            dataHook: obj.dataHook,
        });
    };
}
exports.enzymeTestkitFactoryCreator = enzymeTestkitFactoryCreator;
function enzymeUniTestkitFactoryCreator(driverFactory) {
    return function (obj) {
        var regexp = new RegExp("^<[^>]+data-hook=\"" + obj.dataHook + "\"");
        var component = obj.wrapper.findWhere(function (n) { return n.length > 0 && typeof n.type() === 'string' && regexp.test(n.html()); });
        var element = component.length > 0 ? component.first().getDOMNode() : undefined;
        var base = jsdom_react_1.jsdomReactUniDriver(element);
        var body = jsdom_react_1.jsdomReactUniDriver(document.body);
        return driverFactory(base, body, { dataHook: obj.dataHook });
    };
}
exports.enzymeUniTestkitFactoryCreator = enzymeUniTestkitFactoryCreator;
/**
 * Checks if the given Element accepts a data hook, and that the testkit factory finds the component's root element using that data hook.
 *
 * This method supports both new snake-case and legacy camelCase data hook prop name (e.g `data-hook` and `dataHook`).
 * The default is to check by both prop name options.
 */
function isEnzymeTestkitExists(Element, testkitFactory, mount, options) {
    if (options === void 0) { options = {}; }
    return isEnzymeTestkitExistsInternal(__assign({ Element: Element,
        testkitFactory: testkitFactory,
        mount: mount }, options));
}
exports.isEnzymeTestkitExists = isEnzymeTestkitExists;
function isUniEnzymeTestkitExists(Element, testkitFactory, mount, _a) {
    var _b = _a === void 0 ? {} : _a, withoutDataHook = _b.withoutDataHook, dataHookPropName = _b.dataHookPropName;
    return __awaiter(this, void 0, void 0, function () {
        var dataHook, extraProps, elementToRender, wrapper, testkit;
        var _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    dataHook = withoutDataHook ? '' : 'myDataHook';
                    extraProps = dataHookPropName
                        ? (_c = {}, _c[dataHookPropName] = dataHook, _c) : { dataHook: dataHook, 'data-hook': dataHook };
                    elementToRender = React.cloneElement(Element, extraProps);
                    wrapper = mount(elementToRender);
                    testkit = testkitFactory({ wrapper: wrapper, dataHook: dataHook });
                    return [4 /*yield*/, testkit.exists()];
                case 1: return [2 /*return*/, _d.sent()];
            }
        });
    });
}
exports.isUniEnzymeTestkitExists = isUniEnzymeTestkitExists;
/**
 * This internal function is only in order to allow separate defaults to each options.
 */
function isEnzymeTestkitExistsInternal(_a) {
    var _b;
    var Element = _a.Element, testkitFactory = _a.testkitFactory, mount = _a.mount, _c = _a.withoutDataHook, withoutDataHook = _c === void 0 ? false : _c, dataHookPropName = _a.dataHookPropName;
    var dataHook = withoutDataHook ? '' : 'myDataHook';
    var extraProps = dataHookPropName
        ? (_b = {}, _b[dataHookPropName] = dataHook, _b) : { dataHook: dataHook, 'data-hook': dataHook };
    var elementToRender = React.cloneElement(Element, extraProps);
    var wrapper = mount(elementToRender);
    var testkit = testkitFactory({ wrapper: wrapper, dataHook: dataHook });
    return testkit.exists();
}
//# sourceMappingURL=enzyme.js.map