"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.consoleErrors = void 0;
/* tslint:disable-next-line no-console*/
var originConsoleError = console.error;
var errors = [];
/* tslint:disable-next-line no-console*/
console.error = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    errors.push(args);
    originConsoleError.apply(console, args);
};
exports.consoleErrors = {
    reset: function () { return errors = []; },
    get: function () { return errors.slice().map(function (args) { return args.reduce(function (acc, arg) { return acc + arg; }, ''); }); }
};
beforeEach(function () { return errors = []; });
afterEach(function () {
    if (errors.length > 0) {
        throw new Error("Test has " + errors.length + " Unhandled Errors:\n" + errors);
    }
});
//# sourceMappingURL=index.js.map