import { UniDriver } from '@unidriver/core';
import { StateValue, LegacyStylesheet, CompatStylesheet, CommonStylesheet } from './legacy-stylable-types';
/**
 * LEGACY SUPPORT
 */
export declare class StylableUnidriverUtilLegacy {
    private style;
    constructor(style: LegacyStylesheet);
    hasStyleState(base: UniDriver, stateName: string, param?: StateValue): Promise<boolean>;
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    getStyleState(base: UniDriver, stateName: string): Promise<string | null>;
    private getStateDataAttrKey;
}
export declare class StylableUnidriverUtilCompat {
    private style;
    constructor(style: CompatStylesheet);
    hasStyleState(base: UniDriver, stateName: string, param?: StateValue): Promise<boolean>;
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    getStyleState(base: UniDriver, stateName: string): Promise<string | true | null>;
    getStateValueFromClassName(cls: string, baseState: string): string;
    private getBaseStateWithParam;
}
export declare class StylableCompatUniDriver {
    private style;
    private internal;
    constructor(style: CommonStylesheet);
    hasStyleState(base: UniDriver, stateName: string, param?: StateValue): Promise<boolean>;
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    getStyleState(base: UniDriver, stateName: string): Promise<any>;
}
