"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StylableCompatUniDriver = exports.StylableUnidriverUtilCompat = exports.StylableUnidriverUtilLegacy = void 0;
var uni_driver_1 = require("@stylable/uni-driver");
/**
 * LEGACY SUPPORT
 */
var StylableUnidriverUtilLegacy = /** @class */ (function () {
    function StylableUnidriverUtilLegacy(style) {
        this.style = style;
    }
    StylableUnidriverUtilLegacy.prototype.hasStyleState = function (base, stateName, param) {
        if (param === void 0) { param = true; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, stateKey, styleState, actual;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.getStateDataAttrKey(stateName, param), stateKey = _a.stateKey, styleState = _a.styleState;
                        return [4 /*yield*/, base.attr(stateKey)];
                    case 1:
                        actual = _b.sent();
                        return [2 /*return*/, String(styleState[stateKey]) === actual];
                }
            });
        });
    };
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    StylableUnidriverUtilLegacy.prototype.getStyleState = function (base, stateName) {
        return __awaiter(this, void 0, void 0, function () {
            var stateKey;
            return __generator(this, function (_a) {
                stateKey = this.getStateDataAttrKey(stateName).stateKey;
                return [2 /*return*/, base.attr(stateKey)];
            });
        });
    };
    StylableUnidriverUtilLegacy.prototype.getStateDataAttrKey = function (state, param) {
        var _a;
        if (param === void 0) { param = true; }
        var styleState = this.style.$cssStates((_a = {}, _a[state] = param, _a));
        return { stateKey: Object.keys(styleState)[0], styleState: styleState };
    };
    return StylableUnidriverUtilLegacy;
}());
exports.StylableUnidriverUtilLegacy = StylableUnidriverUtilLegacy;
var stateMiddleDelimiter = '-';
var StylableUnidriverUtilCompat = /** @class */ (function () {
    function StylableUnidriverUtilCompat(style) {
        this.style = style;
    }
    StylableUnidriverUtilCompat.prototype.hasStyleState = function (base, stateName, param) {
        if (param === void 0) { param = true; }
        return __awaiter(this, void 0, void 0, function () {
            var stateClass;
            var _a;
            return __generator(this, function (_b) {
                stateClass = this.style.$cssStates((_a = {}, _a[stateName] = param, _a)).className;
                return [2 /*return*/, base.hasClass(stateClass)];
            });
        });
    };
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    StylableUnidriverUtilCompat.prototype.getStyleState = function (base, stateName) {
        return __awaiter(this, void 0, void 0, function () {
            var className, classList, booleanState, baseState, paramValue;
            var _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, base.attr('class')];
                    case 1:
                        className = (_b.sent()) || '';
                        if (!className.includes(stateName)) {
                            return [2 /*return*/, null];
                        }
                        classList = className.trim().split(/\s+/);
                        booleanState = this.style.$cssStates((_a = {}, _a[stateName] = true, _a)).className;
                        if (classList.includes(booleanState)) {
                            return [2 /*return*/, true];
                        }
                        baseState = this.getBaseStateWithParam(stateName);
                        paramValue = '';
                        classList.forEach(function (cls) {
                            if (!paramValue) {
                                paramValue = _this.getStateValueFromClassName(cls, baseState);
                            }
                        });
                        return [2 /*return*/, paramValue ? paramValue : null];
                }
            });
        });
    };
    StylableUnidriverUtilCompat.prototype.getStateValueFromClassName = function (cls, baseState) {
        if (cls.startsWith(baseState)) {
            var param = cls.slice(baseState.length);
            var paramIndex = param.indexOf(stateMiddleDelimiter);
            if (paramIndex !== -1) {
                return param.slice(paramIndex + 1);
            }
        }
        return '';
    };
    StylableUnidriverUtilCompat.prototype.getBaseStateWithParam = function (stateName) {
        var _a;
        var singleCharState = 'x';
        return this.style
            .$cssStates((_a = {}, _a[stateName] = singleCharState, _a))
            .className.slice(0, -3);
    };
    return StylableUnidriverUtilCompat;
}());
exports.StylableUnidriverUtilCompat = StylableUnidriverUtilCompat;
var StylableCompatUniDriver = /** @class */ (function () {
    function StylableCompatUniDriver(style) {
        this.style = style;
        var mode = getStylesheetMode(this.style || { $cssStates: function () { return {}; } });
        if (mode === 'v2') {
            this.internal = new uni_driver_1.StylableUnidriverUtil(this
                .style);
        }
        else if (mode === 'compat') {
            this.internal = new StylableUnidriverUtilCompat(this
                .style);
        }
        else {
            this.internal = new StylableUnidriverUtilLegacy(this
                .style);
        }
    }
    StylableCompatUniDriver.prototype.hasStyleState = function (base, stateName, param) {
        if (param === void 0) { param = true; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.internal.hasStyleState(base, stateName, param)];
            });
        });
    };
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    StylableCompatUniDriver.prototype.getStyleState = function (base, stateName) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.internal.getStyleState(base, stateName)];
            });
        });
    };
    return StylableCompatUniDriver;
}());
exports.StylableCompatUniDriver = StylableCompatUniDriver;
function getStylesheetMode(sheet) {
    if (sheet.$cssStates) {
        var res = typeof sheet.$cssStates === 'function' ? sheet.$cssStates({}) : {};
        if (res.hasOwnProperty('className')) {
            return 'compat';
        }
        else {
            return 'legacy';
        }
    }
    else {
        return 'v2';
    }
}
//# sourceMappingURL=stylable-unidriver-util-legacy.js.map