import * as React from 'react';
import { Simulate } from 'react-dom/test-utils';
import { BaseDriver } from '../driver-factory';
import { BaseUniDriver } from '../base-driver';
import { UniDriver } from '@unidriver/core';
export interface TestkitArgs {
    wrapper: Element;
    dataHook: string;
}
export declare type TestkitOutputRegular<T extends BaseDriver> = (data: {
    element: Element | undefined;
    wrapper: Element;
    eventTrigger: typeof Simulate;
    dataHook: string;
}) => T;
export declare type TestkitOutputUni<T extends BaseUniDriver> = (base: UniDriver, body: UniDriver, options: {
    dataHook: string;
}) => T;
export declare function testkitFactoryCreator<T extends BaseDriver>(driverFactory: TestkitOutputRegular<T>): (testkitArgs: TestkitArgs) => T;
export declare function uniTestkitFactoryCreator<T extends BaseUniDriver>(driverFactory: TestkitOutputUni<T>): (testkitArgs: TestkitArgs) => T;
export declare function isTestkitExists<T extends BaseDriver>(Element: React.ReactElement<any>, testkitFactory: (obj: {
    wrapper: any;
    dataHook: string;
}) => T, options?: {
    dataHookPropName?: string;
}): boolean;
export declare function isUniTestkitExists<T extends BaseUniDriver>(Element: React.ReactElement<any>, testkitFactory: (obj: {
    wrapper: any;
    dataHook: string;
}) => T, options?: {
    dataHookPropName?: string;
}): Promise<boolean>;
