"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUniTestkitExists = exports.isTestkitExists = exports.uniTestkitFactoryCreator = exports.testkitFactoryCreator = void 0;
var React = require("react");
var ReactDom = require("react-dom");
var test_utils_1 = require("react-dom/test-utils");
var react_helpers_1 = require("../react-helpers");
var jsdom_react_1 = require("@unidriver/jsdom-react");
var getElement = function (_a) {
    var wrapper = _a.wrapper, dataHook = _a.dataHook;
    var domInstance = ReactDom.findDOMNode(wrapper);
    if (domInstance) {
        var dataHookOnInstance = domInstance.attributes.getNamedItem('data-hook') || { value: '' };
        return dataHook === dataHookOnInstance.value
            ? domInstance
            : domInstance.querySelector("[data-hook='" + dataHook + "']");
    }
};
function testkitFactoryCreator(driverFactory) {
    return function (testkitArgs) {
        return driverFactory({
            element: getElement(testkitArgs),
            wrapper: testkitArgs.wrapper,
            eventTrigger: react_helpers_1.reactEventTrigger(),
            dataHook: testkitArgs.dataHook,
        });
    };
}
exports.testkitFactoryCreator = testkitFactoryCreator;
function uniTestkitFactoryCreator(driverFactory) {
    return function (testkitArgs) {
        var element = getElement(testkitArgs);
        return driverFactory(jsdom_react_1.jsdomReactUniDriver(element), jsdom_react_1.jsdomReactUniDriver(document.body), { dataHook: testkitArgs.dataHook });
    };
}
exports.uniTestkitFactoryCreator = uniTestkitFactoryCreator;
function isTestkitExists(Element, testkitFactory, options) {
    var _a;
    var div = document.createElement('div');
    var dataHook = 'myDataHook';
    var dataHookPropName = options && options.dataHookPropName;
    var extraProps = dataHookPropName
        ? (_a = {}, _a[dataHookPropName] = dataHook, _a) : { 'data-hook': dataHook, dataHook: dataHook }; // For backward compatibility add dataHook which is used in Wix-Style-React
    var elementToRender = React.cloneElement(Element, extraProps);
    var renderedElement = test_utils_1.renderIntoDocument(React.createElement("div", null, elementToRender));
    var wrapper = div.appendChild(renderedElement);
    var testkit = testkitFactory({ wrapper: wrapper, dataHook: dataHook });
    return testkit.exists();
}
exports.isTestkitExists = isTestkitExists;
function isUniTestkitExists(Element, testkitFactory, options) {
    return __awaiter(this, void 0, void 0, function () {
        var div, dataHook, dataHookPropName, extraProps, elementToRender, renderedElement, wrapper, testkit;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    div = document.createElement('div');
                    dataHook = 'myDataHook';
                    dataHookPropName = options && options.dataHookPropName;
                    extraProps = dataHookPropName
                        ? (_a = {}, _a[dataHookPropName] = dataHook, _a) : { 'data-hook': dataHook, dataHook: dataHook };
                    elementToRender = React.cloneElement(Element, extraProps);
                    renderedElement = test_utils_1.renderIntoDocument(React.createElement("div", null, elementToRender));
                    wrapper = div.appendChild(renderedElement);
                    testkit = testkitFactory({ wrapper: wrapper, dataHook: dataHook });
                    return [4 /*yield*/, testkit.exists()];
                case 1: return [2 /*return*/, _b.sent()];
            }
        });
    });
}
exports.isUniTestkitExists = isUniTestkitExists;
//# sourceMappingURL=vanilla.js.map