"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dom_1 = require("../src/dom");
describe('Hook helpers', function () {
    it('finds elements with a given hook in a parent element', function () {
        var div = document.createElement('div');
        div.innerHTML = "\n      <tree data-hook=\"inedible\">\n        <apple data-hook=\"edible\"></apple>\n        <leaf data-hook=\"inedible\"></leaf>\n      </div>\n    ";
        expect(dom_1.queryHook(div, 'edible').tagName).toBe('APPLE');
        expect(dom_1.queryHook(div, 'inedible').tagName).toBe('TREE');
        expect(dom_1.queryHookAll(div, 'inedible')[0].tagName).toBe('TREE');
        expect(dom_1.queryHookAll(div, 'inedible')[1].tagName).toBe('LEAF');
    });
    it('matches element that has multiple hooks by one of them', function () {
        var div = document.createElement('div');
        div.innerHTML = '<div data-hook="first second third"></div>';
        expect(dom_1.queryHook(div, 'second')).toBeTruthy();
    });
    it("doesn't match given only a substring of the hook name", function () {
        var div = document.createElement('div');
        div.innerHTML = '<div data-hook="awesome-hook"></div>';
        expect(dom_1.queryHook(div, 'awesome')).toBeNull();
    });
});
//# sourceMappingURL=dom.spec.js.map