"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var protractor_helpers_1 = require("../src/protractor/protractor-helpers");
describe('protractor-helpers', function () {
    describe('getStoryUrl', function () {
        var kind = '3. Inputs';
        var story = '3.2 + InputArea';
        var EXPECTED_URL_BASE = 'iframe.html?selectedKind=3.%20Inputs&selectedStory=3.2%20%2B%20InputArea';
        it('Should create story url using deprecated version', function () {
            expect(protractor_helpers_1.getStoryUrl(kind, story))
                .toEqual(EXPECTED_URL_BASE + "&withExamples");
        });
        it('Should create story url with options', function () {
            expect(protractor_helpers_1.createStoryUrl({ kind: kind, story: story }))
                .toEqual(EXPECTED_URL_BASE + "&withExamples");
        });
        it('Should create story url without examples', function () {
            expect(protractor_helpers_1.createStoryUrl({ kind: kind, story: story, withExamples: false }))
                .toEqual(EXPECTED_URL_BASE);
        });
        it('Should create story url with examples', function () {
            expect(protractor_helpers_1.createStoryUrl({ kind: kind, story: story, withExamples: true }))
                .toEqual(EXPECTED_URL_BASE + "&withExamples");
        });
    });
});
//# sourceMappingURL=protractor-helpers.spec.js.map