"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var puppeteer = require("puppeteer");
var puppeteer_1 = require("../src/puppeteer");
var base_driver_1 = require("../src/base-driver");
var mockTestkit = function (base) {
    return __assign(__assign({}, base_driver_1.baseUniDriverFactory(base)), { text: function () { return base.text(); }, getTestAttr: function () { return base.attr('data-test'); } });
};
var mockHtml = "\n<html>\n  <body>\n    <div data-hook=\"dataHook\">content</div>\n  </body>\n</html>\n".trim();
var mockNestedHtml = "\n  <html>\n    <body>\n      <div data-hook=\"dataHook\">fake content</div>\n      <div data-hook=\"wrapper\">\n        <div data-test=\"skip-me\">\n          <div data-test=\"find-me\" data-hook=\"dataHook\">\n            real content\n          </div>\n        </div>\n      </div>\n    </body>\n  </html>\n".trim();
describe('puppeteerUniTestkitFactoryCreator', function () {
    var browser, page;
    beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, puppeteer.launch()];
                case 1:
                    browser = _a.sent();
                    return [4 /*yield*/, browser.newPage()];
                case 2:
                    page = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, browser.close()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return testkit factory which returns testkit instance', function () { return __awaiter(void 0, void 0, void 0, function () {
        var testkitFactory, testkit, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    page.setContent(mockHtml);
                    testkitFactory = puppeteer_1.puppeteerUniTestkitFactoryCreator(mockTestkit);
                    return [4 /*yield*/, testkitFactory({
                            page: page,
                            dataHook: 'dataHook'
                        })];
                case 1:
                    testkit = _b.sent();
                    expect(testkit).toEqual(expect.objectContaining({
                        exists: expect.any(Function),
                        element: expect.any(Function),
                        click: expect.any(Function)
                    }));
                    _a = expect;
                    return [4 /*yield*/, testkit.text()];
                case 2:
                    _a.apply(void 0, [_b.sent()]).toEqual('content');
                    return [2 /*return*/];
            }
        });
    }); });
    describe('`wrappper`', function () {
        it('should return testkit factory which returns testkit instance', function () { return __awaiter(void 0, void 0, void 0, function () {
            var testkitFactory, testkit, _a, _b, _c;
            var _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        page.setContent(mockNestedHtml);
                        testkitFactory = puppeteer_1.puppeteerUniTestkitFactoryCreator(mockTestkit);
                        _a = testkitFactory;
                        _d = {
                            page: page,
                            dataHook: 'dataHook'
                        };
                        return [4 /*yield*/, page.$('[data-hook="wrapper"]')];
                    case 1: return [4 /*yield*/, _a.apply(void 0, [(_d.wrapper = _e.sent(),
                                _d)])];
                    case 2:
                        testkit = _e.sent();
                        _b = expect;
                        return [4 /*yield*/, testkit.text()];
                    case 3:
                        _b.apply(void 0, [(_e.sent()).trim()]).toEqual('real content');
                        _c = expect;
                        return [4 /*yield*/, testkit.getTestAttr()];
                    case 4:
                        _c.apply(void 0, [_e.sent()]).toEqual('find-me');
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=puppeteer.spec.js.map